import {FirestoreClient, FirestoreUtil} from "../FirestoreClient"
import * as admin from "firebase-admin";
import Timestamp = admin.firestore.Timestamp;
import {expect} from "@jest/globals";



const firestoreMock = { collection: jest.fn() }
const firestoreCollectionMock = {
    add: jest.fn(),
}
const firestoreDocRefMock = {
    get: jest.fn()
}

const firestoreClient = new FirestoreClient(firestoreMock as any)

afterEach(() => {
    jest.clearAllMocks(); // Restore the default sandbox here
});


describe('Unit Tests', () => {

    it('should create a collection reference', async() => {
        //given
        const collectionName = "test-collection"


        //when
        firestoreClient.getCollection(collectionName)

        //then
        expect(firestoreMock.collection).toBeCalledTimes(1)
        expect(firestoreMock.collection.mock.calls[0][0]).toBe(collectionName)

    });

    it('should validate dates', async() => {
        const d = FirestoreUtil.parseIsoDate("2020-04-03T06:35:10Z")
        expect(d).toBeDefined()


        const d2 = FirestoreUtil.parseIsoDate("2020-04-03T06:35:10.100Z")
        expect(d2).toBeDefined()
    });
});
